<?php
global $ow_custom_statuses;
$selected_term = FALSE;
if(isset($_GET['category']) && !empty($_GET['category']) && isset($_GET['nonce']) && wp_verify_nonce( $_GET['nonce'], 'category_filter')) {
   $selected_term = trim($_GET['category']);
}

// sanitize the data
$selected_user = (isset( $_GET['user'] ) && sanitize_text_field( $_GET["user"] )) ? intval( sanitize_text_field( $_GET["user"] )) : get_current_user_id();
$page_number = (isset($_GET['paged']) && sanitize_text_field( $_GET["paged"] )) ? intval( sanitize_text_field( $_GET["paged"] )) : 1;

$ow_inbox_service = new OW_Inbox_Service();
$ow_process_flow = new OW_Process_Flow();
$ow_workflow_service = new OW_Workflow_Service();

// get assigned posts for selected user
$inbox_items = $ow_process_flow->get_assigned_post( null, $selected_user ) ;
$count_posts = count( $inbox_items );
$per_page = OASIS_PER_PAGE;

// TODO: see how to better look into the capabilities of current user
$is_post_editable = current_user_can('edit_others_posts') ;
$current_user_role = OW_Utility::instance()->get_current_user_role() ;
$current_user_id = get_current_user_id();

// get custom terminology
$workflow_terminology_options = get_option( 'oasiswf_custom_workflow_terminology' );
$sign_off_label = ! empty( $workflow_terminology_options['signOffText'] ) ? $workflow_terminology_options['signOffText'] : __( 'Sign Off', 'oasisworkflow' );
$abort_workflow_label = ! empty( $workflow_terminology_options['abortWorkflowText'] ) ? $workflow_terminology_options['abortWorkflowText'] : __( 'Abort Workflow', 'oasisworkflow' );

?>
<div class="wrap">
	<div id="icon-edit" class="icon32 icon32-posts-post"><br></div>
	<h2><?php echo __("Inbox", "oasisworkflow"); ?></h2>
	<div id="workflow-inbox">
		<div class="tablenav top">

      <!-- Bulk Actions Start -->
      <?php do_action( 'owf_bulk_actions_section' ); ?>
      <!-- Bulk Actions End -->

      <input type="hidden" id="hidden_task_user" value="<?php echo esc_attr( $selected_user ); ?>" />
		<?php if ( current_user_can( 'ow_view_others_inbox' )  ){?>
			<div class="alignleft actions">
				<select id="inbox_filter">
				<option value=<?php echo $current_user_id;?> selected="selected"><?php echo __("View inbox of ", "oasisworkflow")?></option>
					<?php
					$assigned_users = $ow_process_flow->get_assigned_users();
					if( $assigned_users )
					{
						foreach ( $assigned_users as $assigned_user ) {
							if( ( isset( $_GET['user'] ) && $_GET["user"] == $assigned_user->ID ) )
								echo "<option value={$assigned_user->ID} selected>{$assigned_user->display_name}</option>" ;
							else
								echo "<option value={$assigned_user->ID}>{$assigned_user->display_name}</option>" ;
						}
					}
					?>
				</select>

				<a href="javascript:window.open('<?php echo admin_url('admin.php?page=oasiswf-inbox&user=')?>' + jQuery('#inbox_filter').val(), '_self')">
					<input type="button" class="button-secondary action" value="<?php echo __("Show", "oasisworkflow"); ?>" />
				</a>
			</div>
		<?php }?>
			<ul class="subsubsub"></ul>
			<div class="tablenav-pages">
				<?php OW_Utility::instance()->get_page_link( $count_posts, $page_number, $per_page );?>
			</div>
		</div>
		<table class="wp-list-table widefat fixed posts" cellspacing="0" border=0>
			<thead>
				<?php $ow_inbox_service->get_table_header();?>
			</thead>
			<tfoot>
				<?php $ow_inbox_service->get_table_header();?>
			</tfoot>
			<tbody id="coupon-list">
				<?php
					$wf_process_status = get_site_option( "oasiswf_status" ) ;
					$space = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" ;
					if( $inbox_items ):
						$count = 0;
					   $cat_name = '----';
						$start = ( $page_number - 1 ) * $per_page;
						$end = $start + $per_page;
						foreach ( $inbox_items as $inbox_item ){
							if ( $count >= $end )
								break;
							if ( $count >= $start )
							{

                        //$selected_term
								$post_categories = get_the_category( $inbox_item->post_id );
								if ( ! empty ( $post_categories ) ) {
									$cat_name = $post_categories[0]->name;
								}
                        if( $selected_term && $cat_name != $selected_term) {
                           continue;
                        }
                        $post = get_post($inbox_item->post_id);
								$user = get_userdata( $post->post_author ) ;
								$stepId = $inbox_item->step_id;
								if ($stepId <= 0 || $stepId == "" ) {
									$stepId = $inbox_item->review_step_id;
								}
								$step = $ow_workflow_service->get_step_by_id( $stepId ) ;
								$workflow = $ow_workflow_service->get_workflow_by_id( $step->workflow_id );

								$needs_to_be_claimed = $ow_process_flow->check_for_claim( $inbox_item->ID ) ;

								$original_post_id = get_post_meta( $inbox_item->post_id, 'oasis_original', true );
								/*Check due date and make post item background color in red to notify the admin*/
                        $ow_email = new OW_Email();

                        $current_date = Date( " F j, Y " );
								$due_date = OW_Utility::instance()->format_date_for_display( $inbox_item->due_date );
                        $past_due_date_row_class = '';
                        $past_due_date_field_class = '';
								if( $due_date != "" && strtotime( $due_date ) < strtotime( $current_date ) ) {
   								$past_due_date_row_class = 'past-due-date-row';
   								$past_due_date_field_class = 'past-due-date-field';

								 }
                        echo "<tr id='post-{$inbox_item->post_id}'
                        	class='post-{$inbox_item->post_id} post type-post $past_due_date_row_class
                        	status-pending format-standard hentry category-uncategorized alternate iedit author-other'> " ;
                        $workflow_action_id = esc_attr( $inbox_item->post_id );
								echo "<th scope='row' class='check-column'>
									<input type='checkbox' name='post[]' value={$workflow_action_id} wfid='{$inbox_item->ID}'></th>" ;

								echo "<td><strong>{$post->post_title}";
										// TODO : see if we can find a better solution instead of using _post_states
									_post_states( $post ) ;
								echo "</strong>" ;
								// create the action list
								if( $needs_to_be_claimed ){ // if the item needs to be claimed, only "Claim" action is visible
									echo "<div class='row-actions'>
											<span>
												<a href='#' class='claim' actionid={$inbox_item->ID}>" . __( "Claim", "oasisworkflow") . "</a>
												<span class='loading'>$space</span>
											</span>
										</div>" ;
								} else {
									echo "<div class='row-actions'>" ;
									if( $is_post_editable || ($user->ID == $current_user_id ) ){
										echo "<span><a href='post.php?post={$inbox_item->post_id}&action=edit&oasiswf={$inbox_item->ID}&user={$selected_user}' class='edit' real={$inbox_item->post_id}>" . __("Edit", "oasisworkflow"). "</a></span>&nbsp;|&nbsp;" ;
									}

									echo "<span><a target='_blank' href='" . get_permalink( $inbox_item->post_id ) . "&preview=true'>" . __( "View", "oasisworkflow" ) . "</a></span>&nbsp;|&nbsp;";
									
									if( current_user_can( 'ow_sign_off_step' ) && $is_post_editable || ( $user->ID == $current_user_id ) ){
										echo "<span>
												<a href='#' wfid='$inbox_item->ID' postid='$inbox_item->post_id' class='quick_sign_off'>" . $sign_off_label. "</a>
												<span class='loading'>$space</span>
											</span>&nbsp;|&nbsp;" ;
									}
									if ( current_user_can( 'ow_reassign_task' ) ) {
										echo "<span>
												<a href='#' wfid='$inbox_item->ID' class='reassign'>" . __( "Reassign", "oasisworkflow" ) . "</a>
												<span class='loading'>$space</span>
											</span>&nbsp;|&nbsp;";
									}
									if ( current_user_can( 'ow_abort_workflow' ) ) {
										echo "<span>
										<a href='#' wfid='$inbox_item->ID' postid='$inbox_item->post_id' class='abort_workflow'>" . $abort_workflow_label . "</a>
										<span class='loading'>$space</span>
										</span>&nbsp;|&nbsp;" ;
									}
									if ( current_user_can( 'ow_view_workflow_history' ) ) {
	                           $nonce_url = wp_nonce_url("admin.php?page=oasiswf-history&post=$inbox_item->post_id", 'owf_view_history_nonce');
	                           echo "<span><a href='$nonce_url'> " . __( "View History", "oasisworkflow" ) . "</a></span>";
									}
									echo "</div>";
									get_inline_data( $post );
								}
								echo "</td>";
								echo "<td>{$post->post_type}</td>" ;
								echo "<td>" . OW_Utility::instance()->get_user_name( $user->ID ) . "</td>" ;
								$workflow_name = $workflow->name;
								if (!empty( $workflow->version )) {
									$workflow_name .= " (" . $workflow->version . ")";
								}

								echo "<td>{$workflow_name} [{$ow_workflow_service->get_gpid_dbid( $workflow->ID, $stepId, 'lbl' )}]</td>" ;
                        $arg = add_query_arg(array('category'=>$cat_name, 'nonce' => wp_create_nonce('category_filter')));
                        echo "<td><a href=$arg>{$cat_name}</a></td>" ;

                        $post_status = $ow_custom_statuses->get_single_term_by( 'slug', get_post_status( $post->ID ) );
                        $post_status = is_object( $post_status ) && isset( $post_status->name ) ? $post_status->name : $wf_process_status[$ow_workflow_service->get_gpid_dbid( $workflow->ID, $stepId, 'process' )];
								// if the due date is passed the current date show the field in a different color
                        echo "<td><span class=' . $past_due_date_field_class . '>" . OW_Utility::instance()->format_date_for_display( $inbox_item->due_date ) . "</span></td>" ;

								echo "<td class='comments column-comments'>
										<div class='post-com-count-wrapper'>
											<strong>
												<a href='#' actionid={$inbox_item->ID} class='post-com-count post-com-count-approved' data-comment='inbox_comment' post_id={$inbox_item->post_id}>
													<span class='comment-count-approved'>{$ow_process_flow->get_comment_count( $inbox_item->ID, TRUE, $inbox_item->post_id )}</span>
												</a>
												<span class='loading'>$space</span>
											</strong>
										</div>
									  </td>" ;
								echo "</tr>" ;
							}
							$count++;
						}
					else:
						echo "<tr>" ;
						echo "<td class='hurry-td' colspan='9'>
								<label class='hurray-lbl'>";
						echo __( "Hurray! No assignments", "oasisworkflow" );
						echo "</label></td>" ;
						echo "</tr>" ;
					endif;
				?>
			</tbody>
		</table>
		<div class="tablenav">
			<div class="tablenav-pages">
				<?php OW_Utility::instance()->get_page_link( $count_posts, $page_number, $per_page );?>
			</div>
		</div>
	</div>
</div>
<span id="wf_edit_inline_content"></span>
<div id ="step_submit_content"></div>
<div id="reassign-div"></div>
<div id="post_com_count_content"></div>
<input type="hidden" name="owf_claim_process_ajax_nonce" id="owf_claim_process_ajax_nonce" value="<?php echo wp_create_nonce( 'owf_claim_process_ajax_nonce' ); ?>" />
<input type="hidden" name="owf_inbox_ajax_nonce" id="owf_inbox_ajax_nonce" value="<?php echo wp_create_nonce( 'owf_inbox_ajax_nonce' ); ?>" />