<?php
//----------------
$action = (isset( $_GET['action'] ) && sanitize_text_field( $_GET["action"] )) ? sanitize_text_field( $_GET["action"] ) : "all";
$pagenum = (isset( $_GET['paged'] ) && sanitize_text_field( $_GET["paged"] )) ? intval( sanitize_text_field( $_GET["paged"] ) ) : 1;

$workflow_service = new OW_Workflow_Service();
if ($action == 'hideNotice') {
	update_site_option("oasiswf_show_upgrade_notice", "no") ;
	$workflows = $workflow_service->get_workflow_list( "all" );
	$wf_class["all"] = 'class="current"';
} else {
	$workflows = $workflow_service->get_workflow_list( $action );
	$wf_class[$action] = 'class="current"';
}

$wf_count_by_status = $workflow_service->get_workflow_count_by_status();
$workflow_count = count( $workflows );

$per_page = OASIS_PER_PAGE;
OW_Utility::instance()->owf_pro_features();
?>
<div class="wrap">
   <div id="icon-edit" class="icon32 icon32-posts-post"><br></div>
   <h2><?php echo __( "Edit Workflows", "oasisworkflow" ) ?></h2>
   <div id="view-workflow">
      <div class="tablenav">
         <ul class="subsubsub">
            <?php
            $active_val = isset( $wf_class["active"] ) ? $wf_class["active"] : "";
            $inactive_val = isset( $wf_class["inactive"] ) ? $wf_class["inactive"] : "";
            $all_val = isset( $wf_class["all"] ) ? $wf_class["all"] : "";
            echo '<li class="all"><a href="admin.php?page=oasiswf-admin"' . $all_val . ' >' . __( 'All', "oasisworkflow" ) .
            '<span class="count"> (' . $wf_count_by_status->wf_all . ')</span></a></li>';
            echo ' | <li class="all"><a href="admin.php?page=oasiswf-admin&action=active"' . $active_val . '>' . __( 'Active', "oasisworkflow" ) .
            '<span class="count"> (' . $wf_count_by_status->wf_active . ')</span></a> </li>';
            echo ' | <li class="all"><a href="admin.php?page=oasiswf-admin&action=inactive"' . $inactive_val . '>' . __( 'Inactive', "oasisworkflow" ) .
            '<span class="count"> (' . $wf_count_by_status->wf_inactive . ')</span></a> </li>';
            ?>
         </ul>
         <div class="tablenav-pages">
            <?php OW_Utility::instance()->get_page_link( $workflow_count, $pagenum, $per_page ); ?>
         </div>

      </div>
      <form method="post">
         <table class="wp-list-table widefat fixed posts" cellspacing="0" border=0>
            <thead>
               <?php $workflow_service->get_table_header(); ?>
            </thead>
            <tfoot>
               <?php $workflow_service->get_table_header(); ?>
            </tfoot>
            <tbody id="coupon-list">
               <?php
               if( $workflows ):
                  $act = array( "", "active" );
                  $count = 0;
                  $start = ($pagenum - 1) * $per_page;
                  $end = $start + $per_page;
                  foreach ( $workflows as $wf ) {
                     if( $count >= $end )
                        break;
                     if( $count >= $start ) {
                        $postcount = $workflow_service->get_post_count_in_workflow( $wf->ID );
                        $valid = ( $wf->is_valid ) ? "Yes" : "No";
                        echo "<tr class='alternate author-self status-publish format-default iedit'>";
                        echo "<th scope='row' class='check-column'><input type='checkbox' name='workflows[]' value='" . esc_attr( $wf->ID ) . "'></th>";
                        echo "<td>
										<a href='admin.php?page=oasiswf-admin&wf_id=" . $wf->ID . "'><strong>{$wf->name}</strong></a>
										<div class='row-actions'>";
                        if( current_user_can( 'ow_edit_workflow' ) ) {
                           echo "<span><a href='admin.php?page=oasiswf-admin&wf_id=" . $wf->ID . "'>" . __( "Edit", "oasisworkflow" ) . "</a></span>";
                        }
                        $action_url = admin_url( 'admin.php?page=oasiswf-admin' );
                        echo "</div>
									</td>";
                        echo "<td>{$wf->version}</td>";
                        echo "<td>" . OW_Utility::instance()->format_date_for_display( $wf->start_date ) . "</td>";
                        echo "<td>" . OW_Utility::instance()->format_date_for_display( $wf->end_date ) . "</td>";
                        echo "<td>{$postcount}</td>";
                        echo "<td>{$valid}</td>";
                        echo "</tr>";
                     }
                     $count ++;
                  }
               else:
						$msg = "<label>" . __("You don't have any workflows.", "oasisworkflow") . "</label>";
						echo "<tr>" ;
						echo "<td colspan='8' class='no-found-lbl'>$msg</td>" ;
						echo "</tr>" ;
               endif;
               ?>
            </tbody>
         </table>
      </form>
      <div class="tablenav">
         <div class="tablenav-pages">
            <?php OW_Utility::instance()->get_page_link( $workflow_count, $pagenum, $per_page ); ?>
         </div>
      </div>
   </div>
</div>