jQuery(document).ready(function () {

	jQuery(document).on("mouseover", "#step-setting a", function () {
        jQuery(this).css({"color": "red"});
    });
	
    jQuery(document).on("mouseout", "#step-setting a", function () {
        jQuery(this).css({"color": "blue"});
    });

    jQuery(document).on('click', '#step_email_content > .nav-tab', function (e) {
        e.preventDefault();
        var tab = jQuery(this).attr('href');
        if (tab == '#assignment_email') {
            jQuery(this).addClass('nav-tab-active').next().removeClass('nav-tab-active');
            jQuery('#reminder_email').hide();
        } else {
            jQuery(this).addClass('nav-tab-active').prev().removeClass('nav-tab-active');
            jQuery('#assignment_email').hide();
        }
        jQuery(tab).fadeIn('slow');

    });

    /*
     * Assigning a role to a step
     */
    jQuery(document).on("click", "#step-assignee-set-point", function () {
        var v = jQuery('#step-role-list option:selected').val();
        var t = jQuery('#step-role-list option:selected').text();
        if (option_exist_chk(v))
            jQuery('#step-role-set-list').append('<option value=' + v + '>' + t + '</option>');
    });
    
    /*
     * Unassigning a role from a given step
     */

    jQuery(document).on("click", "#step-assignee-unset-point", function () {
        var v = jQuery('#step-role-set-list option:selected').val();
        jQuery("#step-role-set-list option[value='" + v + "']").remove();
    });

    /*
     * Cancelling/Closing the step popup
     */
    jQuery(document).on("click", "#stepCancel", function () {
        jQuery.modal.close();
    });

    /*
     * Saving a step information
     */
    jQuery(document).on("click", "#stepSave", function () {
        if (!validate_step_data()) {
            return;
    	}

        var savedata = new Array();
        var step_gpid = jQuery.trim( jQuery("#step_gpid-hi").val().escapeSpecialChars() ) ;
        savedata = get_step_data();
        jQuery(".step-set span").addClass("loading");
        data = {
            action: 'save_workflow_step',
            wf_id: jQuery.trim( jQuery(document).find("#wf_id").val().escapeSpecialChars() ),
            step_gp_id:  jQuery.trim( jQuery(document).find( "#" + step_gpid ).attr("id").escapeSpecialChars() ),
            step_id: jQuery.trim( jQuery(document).find( "#" + step_gpid ).attr("db-id").escapeSpecialChars() ),
            step_name: jQuery("#step-name").val(),
            act: jQuery(document).find("#" + step_gpid).attr("real"),
            step_info: savedata[0],
            process_info: savedata[1],
            security: jQuery('#owf_workflow_create_nonce').val()
        };
        jQuery.post(ajaxurl, data, function (response) {
            if(response.trim() == -1){ // nonce cannot be verified
            	jQuery(".changed-data-set span").removeClass("loading");
                return "0";
            }        	
            jQuery(".step-set span").removeClass("loading");
            var saved_step_id = response.trim();
            jQuery(document).find("#" + step_gpid).attr({"db-id": saved_step_id});
            
            // hook for saving condition group with the step information
            owChecklistConditionGroup.addToStep( saved_step_id );
            
            return saved_step_id;
        });        

    });

    // assignment subject
    jQuery(document).on("click", "#addPlaceholderAssignmentSubj", function () {
        if (jQuery(this).parent().children("select").val() == '') {
            alert( owf_workflow_step_info_vars.selectPlaceholder );
            return false;
        }
        var v = jQuery(this).parent().children("select").val() + " "; //add a space after the placeholder
        jQuery("#assignment-email-subject").insertAtCaret(v);
    });

    // assignment message
    jQuery(document).on("click", "#addPlaceholderAssignmentMsg", function () {
        if (jQuery(this).parent().children("select").val() == '') {
            alert( owf_workflow_step_info_vars.selectPlaceholder );
            return false;
        }
        var v = jQuery(this).parent().children("select").val() + " "; //add a space after the placeholder
        setCurrentWhizzy('assignment-email-content');
        insHTML(v);
        jQuery("#addPlaceholderAssignmentMsg").focus();
    });

    // reminder subject
    jQuery(document).on("click", "#addPlaceholderReminderSubj", function () {
        if (jQuery(this).parent().children("select").val() == '') {
            alert( owf_workflow_step_info_vars.selectPlaceholder );
            return false;
        }
        var v = jQuery(this).parent().children("select").val() + " "; //add a space after the placeholder
        jQuery("#reminder-email-subject").insertAtCaret(v);
    });

    // reminder message
    jQuery(document).on("click", "#addPlaceholderReminderMsg", function () {
        if (jQuery(this).parent().children("select").val() == '') {
            alert(owf_workflow_step_info_vars.selectPlaceholder);
            return false;
        }
        var v = jQuery(this).parent().children("select").val() + " "; //add a space after the placeholder
        setCurrentWhizzy('reminder-email-content');
        insHTML(v);
        jQuery("#addPlaceholderReminderMsg").focus();
    });

    // fix for cursor to stay in the place where user has clicked
    jQuery.fn.extend({
        insertAtCaret: function (myValue) {
            return this.each(function (i) {
                if (document.selection) {
                    //For browsers like Internet Explorer
                    this.focus();
                    sel = document.selection.createRange();
                    sel.text = myValue;
                    this.focus();
                }
                else if (this.selectionStart || this.selectionStart == '0') {
                    //For browsers like Firefox and Webkit based
                    var startPos = this.selectionStart;
                    var endPos = this.selectionEnd;
                    var scrollTop = this.scrollTop;
                    this.value = this.value.substring(0, startPos) + myValue + this.value.substring(endPos, this.value.length);
                    this.focus();
                    this.selectionStart = startPos + myValue.length;
                    this.selectionEnd = startPos + myValue.length;
                    this.scrollTop = scrollTop;
                } else {
                    this.value += myValue;
                    this.focus();
                }
            })
        }
    });

    var option_exist_chk = function (val) {
        if (jQuery('#step-role-set-list option[value=' + val + ']').length > 0) {
            return false;
        } else {
            return true;
        }
    }

    /*
     * validate step data before saving
     */
    var validate_step_data = function () {
    	// step name cannot be empty
        if (!jQuery("#step-name").val()) {
            alert(owf_workflow_step_info_vars.stepNameRequired);
            return false;
        }

        // step name already exists
        var valid = true;
        var step_gpid = jQuery("#step_gpid-hi").val();
        jQuery(document).find(".fc_action .w").each(function () {
            var lbl = jQuery(this).children("label").html();
            if (jQuery(this).attr("id") != step_gpid) {
                var step_name = jQuery("#step-name").val();
                if (jQuery.trim(lbl) == jQuery.trim(step_name))
                    valid = false;
            }
        });

        if (!valid) {
            alert(owf_workflow_step_info_vars.stepNameAlreadyExists);
            return false;
        }

        // assignees not selected
        var optionNum = jQuery("#step-role-set-list option").length;
        if (!optionNum) {
            alert(owf_workflow_step_info_vars.selectAssignees);
            return false;
        }

        // status on success cannot be empty
        if (!jQuery("#step-status-select").val() && !jQuery("#step_status_publish").is(':visible')) {
            alert(owf_workflow_step_info_vars.statusOnSuccess);
            return false;
        }

        // status on failure cannot be empty
        if (!jQuery("#step-failure-status-select").val()) {
            alert(owf_workflow_step_info_vars.statusOnFailure);
            return false;
        }

        return true;
    }
    
    var get_step_data = function () {
        var step_info_array = {};
        var process_info_array = {};
        var assignee = {};

        // extract step_info
        var step_gpid = jQuery.trim( jQuery("#step_gpid-hi").val().escapeSpecialChars() ) ;
        step_info_array["process"] = jQuery(document).find("#" + step_gpid).attr("process-name");
        step_info_array["step_name"] = jQuery("#step-name").val();
        step_info_array["assign_to_all"] = jQuery('#assign_to_all:checked').prop('checked') === true ? 1 : 0;
        jQuery('select#step-role-set-list').find('option').each(function () {
            assignee[jQuery(this).val()] = jQuery(this).text();
        });
        step_info_array["assignee"] = assignee;
        if (jQuery("#step_status_publish").is(':visible'))
        {
            step_info_array["status"] = 'publish';
        }
        else
        {
            step_info_array["status"] = jQuery("#step-status-select").val();
        }
        step_info_array["failure_status"] = jQuery("#step-failure-status-select").val();

        // extract process info
        syncTextarea();
        process_info_array["assign_subject"] = jQuery.trim( jQuery("#assignment-email-subject").val().escapeSpecialChars() );
        process_info_array["assign_content"] = jQuery.trim( jQuery("#assignment-email-content").val().escapeSpecialChars() );
        process_info_array["reminder_subject"] = jQuery.trim( jQuery("#reminder-email-subject").val().escapeSpecialChars() );
        process_info_array["reminder_content"] = jQuery.trim( jQuery("#reminder-email-content").val().escapeSpecialChars() );

        // convert to json
        step_info = jQuery.toJSON(step_info_array);
        process_info = jQuery.toJSON(process_info_array); // process_info_array
        var step_data = new Array(step_info, process_info);
        return step_data;
    }
});

var jQuerySaveConditionGroup = jQuery.noConflict();
(function(jQuery){
	owChecklistConditionGroup = {
		addToStep : function ( step_id ) {
			if ( typeof addConditionGroupToStep !== 'undefined' ) {
				addConditionGroupToStep( step_id );
			}

            // TODO: if nonce is not correct then it returns always -1 not 0
            if ( step_id == "0" ) { // nonce verfication failed
            	return;
            }
    		var step_gpid = jQuery("#step_gpid-hi").val() ;
    		jQuery(document).find("#" + step_gpid + " label").html(jQuery("#step-name").val()) ;
    		if(jQuery("#first_step_check").attr("checked")){
    			jQuery(document).find("#" + step_gpid).attr("first_step", "yes") ;
    			jQuery(document).find("#" + step_gpid).css("background-color", "#99CCFF");
    			jQuery(document).find("#" + step_gpid).children("label").css("color", "#000");
    		}else{
    			jQuery(document).find("#" + step_gpid).attr("first_step", "no") ;
    			jQuery(document).find("#" + step_gpid).css("background-color", "#FFFFFF");
    			jQuery(document).find("#" + step_gpid).children("label").css("color", "#444444");			
    		}
    		
    		jQuery.modal.close();  			
		}
	};
} (jQuerySaveConditionGroup));